function[epsilon,xi_prop,beta_prop,nseg_new,seg_temp]=within(x,nexp_temp,xi_curr_temp,beta_curr_temp,nseg_curr_temp,tau_temp)
global nobs nbasis nbeta sigmasqalpha prob_mm1 tmin

xi_prop=xi_curr_temp;
beta_prop=beta_curr_temp;
nseg_new=nseg_curr_temp;

if nexp_temp>1
	seg_temp=unidrnd(nexp_temp-1);%Drawing Segment to cut
	u=rand;
    cut_poss_curr=xi_curr_temp(seg_temp);
    nposs_prior=nseg_curr_temp(seg_temp)+nseg_curr_temp(seg_temp+1)-2*tmin+1;
  	if u<prob_mm1
		if nseg_curr_temp(seg_temp)==tmin && nseg_curr_temp(seg_temp+1)==tmin
            nposs=1;% Number of possible locations for new cutpoint
			new_index=unidrnd(nposs);%Drawing index of new cutpoint
			cut_poss_new=xi_curr_temp(seg_temp)-1+new_index;
        elseif nseg_curr_temp(seg_temp)==tmin
			nposs=2;% Number of possible locations for new cutpoint
			new_index=unidrnd(nposs);%Drawing index of new cutpoint
			cut_poss_new=xi_curr_temp(seg_temp)-1+new_index;
        elseif nseg_curr_temp(seg_temp+1)==tmin
			nposs=2;% Number of possible locations for new cutpoint
			new_index=unidrnd(nposs);%Drawing index of new cutpoint
			cut_poss_new=xi_curr_temp(seg_temp)+1-new_index;
        else
			nposs=3;% Number of possible locations for new cutpoint
			new_index=unidrnd(nposs);%Drawing index of new cutpoint 
			cut_poss_new=xi_curr_temp(seg_temp)-2+new_index;
        end
	else
		new_index=unidrnd(nposs_prior);%
		cut_poss_new=sum(nseg_curr_temp(1:seg_temp-1))-1+tmin+new_index;
    end
	xi_prop(seg_temp)=cut_poss_new;
	if(seg_temp>1)
		nseg_new(seg_temp)=xi_prop(seg_temp)-xi_curr_temp(seg_temp-1);%Number of observations in lower part of new cutpoint
	else
		nseg_new(seg_temp)=xi_prop(seg_temp);
	end
	nseg_new(seg_temp+1)=nseg_curr_temp(seg_temp)+nseg_curr_temp(seg_temp+1)-nseg_new(seg_temp);%Number of observations in upper part of new cutpoint
    %Evaluating the Proposal density for the cut-point at the cureent and proposed values
    if(abs(cut_poss_new-cut_poss_curr)>1)
        log_prop_cut_prop=log(1-prob_mm1)-log(nposs_prior);
        log_prop_cut_curr=log(1-prob_mm1)-log(nposs_prior);
    elseif nseg_curr_temp(seg_temp)==tmin && nseg_curr_temp(seg_temp+1)==tmin
        log_prop_cut_prop=0;
        log_prop_cut_curr=0;
    else
        if (nseg_curr_temp(seg_temp)==tmin || nseg_curr_temp(seg_temp+1)==tmin)
           log_prop_cut_prop=log(1-prob_mm1)-log(nposs_prior)+log(1/2)+log(prob_mm1);
        else
           log_prop_cut_prop=log(1-prob_mm1)-log(nposs_prior)+log(1/3)+log(prob_mm1); 
        end
        if(nseg_new(seg_temp)==tmin || nseg_new(seg_temp+1)==tmin)
           log_prop_cut_curr=log(1-prob_mm1)-log(nposs_prior)+log(1/2)+log(prob_mm1);
        else
           log_prop_cut_curr=log(1-prob_mm1)-log(nposs_prior)+log(1/3)+log(prob_mm1); 
        end
    end
        
%Evaluating the Loglikelihood, Priors and Proposals at the current values
	loglike_curr=0;
	log_beta_curr_temp=0;
	log_prior_curr=0;
	for j=seg_temp:seg_temp+1
		[beta_mean beta_var nu_mat y]=postbeta(j,nseg_curr_temp(j),x,xi_curr_temp,tau_temp(j));
		%Compute log proposal density of beta at current  values
		log_beta_curr_temp=log_beta_curr_temp+log(mvnpdf(beta_curr_temp(:,j),beta_mean,0.5*(beta_var+beta_var')));
		fhat=nu_mat*beta_curr_temp(:,j);
		%Compute Loglike at current values
		[log_curr_spec_dens]=whittle_like(y,fhat,nseg_curr_temp(j));
		loglike_curr=loglike_curr+log_curr_spec_dens;
		%Compute priors at current values
		log_prior_curr=log_prior_curr+...
		log(mvnpdf(beta_curr_temp(:,j),zeros(nbeta,1),diag([sigmasqalpha; tau_temp(j)*ones(nbasis,1)])));
	 end
%Evaluating the Loglikelihood, Priors and Proposals at the proposed values
%Likelihood
	loglike_prop=0;
	log_beta_prop=0;
	log_prior_prop=0;
	for j=seg_temp:seg_temp+1
		[beta_mean beta_var nu_mat y]=postbeta(j,nseg_new(j),x,xi_prop,tau_temp(j));
		beta_prop(:,j)=mvnrnd(beta_mean,0.5*(beta_var+beta_var'))';	
		%Compute log proposal density of beta at proposed  values
		log_beta_prop=log_beta_prop+log(mvnpdf(beta_prop(:,j),beta_mean,0.5*(beta_var+beta_var')));
		fhat=nu_mat*beta_prop(:,j);
		%Compute Loglike at proposed values
		[log_prop_spec_dens]=whittle_like(y,fhat,nseg_new(j));
		loglike_prop=loglike_prop+log_prop_spec_dens;
		%Compute priors at proposed values
		log_prior_prop=log_prior_prop+...
		log(mvnpdf(beta_prop(:,j),zeros(nbeta,1),diag([sigmasqalpha; tau_temp(j)*ones(nbasis,1)])));
    end
    %Proposal for beta
     log_proposal_curr=log_beta_curr_temp+log_prop_cut_curr;
	 log_proposal_prop=log_beta_prop+log_prop_cut_prop;
	 log_prior_cut_prop=0;
	 log_prior_cut_curr=0;
	 for k=1:nexp_temp-1
		if k==1
			log_prior_cut_prop=-log(nobs-(nexp_temp-k+1)*tmin+1);
			log_prior_cut_curr=-log(nobs-(nexp_temp-k+1)*tmin+1);
		else
			log_prior_cut_prop=log_prior_cut_prop-log(nobs-xi_prop(k-1)-(nexp_temp-k+1)*tmin+1);
			log_prior_cut_curr=log_prior_cut_curr-log(nobs-xi_curr_temp(k-1)-(nexp_temp-k+1)*tmin+1);
        end
	 end
 log_target_prop=loglike_prop+log_prior_prop+log_prior_cut_prop;
 log_target_curr=loglike_curr+log_prior_curr+log_prior_cut_curr;
else
	nseg_new=nobs;
	seg_temp=1;
	[beta_mean beta_var nu_mat y]=postbeta(1,nobs,x,xi_prop,tau_temp);
	beta_prop(:,1)=mvnrnd(beta_mean,0.5*(beta_var+beta_var'))';
	%Compute log proposal density of beta at proposed  values
	log_beta_prop=log(mvnpdf(beta_prop(:,1),beta_mean,0.5*(beta_var+beta_var')));
	%Compute log proposal density of beta at current  values
	log_beta_curr_temp=log(mvnpdf(beta_curr_temp(:,1),beta_mean,0.5*(beta_var+beta_var')));
	%Compute Loglike at proposed values
	fhat=nu_mat*beta_prop(:,1);
	[loglike_prop]=whittle_like(y,fhat,nobs);
	%Compute Loglike at proposed values
	fhat=nu_mat*beta_curr_temp(:,1);
	[loglike_curr]=whittle_like(y,fhat,nobs);
	%Compute Priors at proposed values
	log_prior_prop=log(mvnpdf(beta_prop(:,1),zeros(nbeta,1),diag([sigmasqalpha; tau_temp*ones(nbasis,1)])));
	%Compute Priors at current values
	log_prior_curr=log(mvnpdf(beta_curr_temp(:,1),zeros(nbeta,1),diag([sigmasqalpha; tau_temp*ones(nbasis,1)])));
	log_proposal_curr=log_beta_curr_temp;
	log_proposal_prop=log_beta_prop;
	log_target_prop=loglike_prop+log_prior_prop;
	log_target_curr=loglike_curr+log_prior_curr;
end
epsilon=min(1,exp(log_target_prop-log_target_curr+log_proposal_curr-log_proposal_prop));
